c# - एक बार में कई अपवादों को पकड़ो?




.net exception (17)

यह System.Exception पकड़ने के लिए निराश है। System.Exception । इसके बजाए, केवल "ज्ञात" अपवादों को पकड़ा जाना चाहिए।

अब, यह कभी-कभी अनपेक्षित दोहराव कोड की ओर जाता है, उदाहरण के लिए:

try
{
    WebId = new Guid(queryString["web"]);
}
catch (FormatException)
{
    WebId = Guid.Empty;
}
catch (OverflowException)
{
    WebId = Guid.Empty;
}

मुझे आश्चर्य है: क्या दोनों अपवादों को पकड़ने का एक तरीका है और केवल WebId = Guid.Empty कॉल को कॉल करें?

दिया गया उदाहरण अपेक्षाकृत सरल है, क्योंकि यह केवल एक GUID । लेकिन कोड की कल्पना करें जहां आप एक ऑब्जेक्ट को कई बार संशोधित करते हैं, और अगर एक मैनिपुलेशन अपेक्षित तरीके से विफल हो जाता है, तो आप object को "रीसेट" करना चाहते हैं। हालांकि, अगर कोई अप्रत्याशित अपवाद है, तो भी मैं उस उच्च को फेंकना चाहता हूं।

https://code.i-harness.com


सावधान और चेतावनी: फिर भी एक और तरह, कार्यात्मक शैली।

लिंक में क्या है सीधे आपके प्रश्न का उत्तर नहीं देता है, लेकिन इसे देखने के लिए इसे विस्तारित करना मुश्किल है:

static void Main() 
{ 
    Action body = () => { ...your code... };

    body.Catch<InvalidOperationException>() 
        .Catch<BadCodeException>() 
        .Catch<AnotherException>(ex => { ...handler... })(); 
}

(मूल रूप से एक और खाली Catch अधिभार प्रदान करता है जो खुद को लौटाता है)

इस के लिए बड़ा सवाल यही है । मुझे नहीं लगता कि लागत यहां लाभ से अधिक है :)


2015-12-15 अपडेट करें: सी # 6 के लिए https://.com/a/22864936/1718702 देखें। यह एक क्लीनर और अब भाषा में मानक है।

उन लोगों के लिए गियर किया गया जो एक बार पकड़ने और अपवाद फ़िल्टर करने के लिए एक अधिक सुरुचिपूर्ण समाधान चाहते हैं, मैं नीचे दिखाए गए एक विस्तार विधि का उपयोग करता हूं।

मेरे पास पहले से ही मेरी लाइब्रेरी में यह एक्सटेंशन था, मूल रूप से अन्य उद्देश्यों के लिए लिखा गया था, लेकिन यह अपवादों पर type जांच के लिए पूरी तरह से काम करता था। इसके अलावा, इमो, यह एक समूह की तुलना में क्लीनर दिखता है || बयान। इसके अलावा, स्वीकार्य उत्तर के विपरीत, मैं स्पष्ट अपवाद हैंडलिंग पसंद करता हूं इसलिए ex is ... अवांछित व्यवहार था क्योंकि वंचित कक्षाएं माता-पिता के प्रकार के लिए असाइन की जा सकती हैं)।

प्रयोग

if (ex.GetType().IsAnyOf(
    typeof(FormatException),
    typeof(ArgumentException)))
{
    // Handle
}
else
    throw;

IsAnyOf.cs एक्सटेंशन (निर्भरता के लिए उदाहरण को पूरा करने में पूर्ण त्रुटि देखें)

namespace Common.FluentValidation
{
    public static partial class Validate
    {
        /// <summary>
        /// Validates the passed in parameter matches at least one of the passed in comparisons.
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="p_parameter">Parameter to validate.</param>
        /// <param name="p_comparisons">Values to compare against.</param>
        /// <returns>True if a match is found.</returns>
        /// <exception cref="ArgumentNullException"></exception>
        public static bool IsAnyOf<T>(this T p_parameter, params T[] p_comparisons)
        {
            // Validate
            p_parameter
                .CannotBeNull("p_parameter");
            p_comparisons
                .CannotBeNullOrEmpty("p_comparisons");

            // Test for any match
            foreach (var item in p_comparisons)
                if (p_parameter.Equals(item))
                    return true;

            // Return no matches found
            return false;
        }
    }
}

पूर्ण त्रुटि हैंडलिंग उदाहरण (नई कंसोल ऐप पर कॉपी-पेस्ट करें)

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Common.FluentValidation;

namespace IsAnyOfExceptionHandlerSample
{
    class Program
    {
        static void Main(string[] args)
        {
            // High Level Error Handler (Log and Crash App)
            try
            {
                Foo();
            }
            catch (OutOfMemoryException ex)
            {
                Console.WriteLine("FATAL ERROR! System Crashing. " + ex.Message);
                Console.ReadKey();
            }
        }

        static void Foo()
        {
            // Init
            List<Action<string>> TestActions = new List<Action<string>>()
            {
                (key) => { throw new FormatException(); },
                (key) => { throw new ArgumentException(); },
                (key) => { throw new KeyNotFoundException();},
                (key) => { throw new OutOfMemoryException(); },
            };

            // Run
            foreach (var FooAction in TestActions)
            {
                // Mid-Level Error Handler (Appends Data for Log)
                try
                {
                    // Init
                    var SomeKeyPassedToFoo = "FooParam";

                    // Low-Level Handler (Handle/Log and Keep going)
                    try
                    {
                        FooAction(SomeKeyPassedToFoo);
                    }
                    catch (Exception ex)
                    {
                        if (ex.GetType().IsAnyOf(
                            typeof(FormatException),
                            typeof(ArgumentException)))
                        {
                            // Handle
                            Console.WriteLine("ex was {0}", ex.GetType().Name);
                            Console.ReadKey();
                        }
                        else
                        {
                            // Add some Debug info
                            ex.Data.Add("SomeKeyPassedToFoo", SomeKeyPassedToFoo.ToString());
                            throw;
                        }
                    }
                }
                catch (KeyNotFoundException ex)
                {
                    // Handle differently
                    Console.WriteLine(ex.Message);

                    int Count = 0;
                    if (!Validate.IsAnyNull(ex, ex.Data, ex.Data.Keys))
                        foreach (var Key in ex.Data.Keys)
                            Console.WriteLine(
                                "[{0}][\"{1}\" = {2}]",
                                Count, Key, ex.Data[Key]);

                    Console.ReadKey();
                }
            }
        }
    }
}

namespace Common.FluentValidation
{
    public static partial class Validate
    {
        /// <summary>
        /// Validates the passed in parameter matches at least one of the passed in comparisons.
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="p_parameter">Parameter to validate.</param>
        /// <param name="p_comparisons">Values to compare against.</param>
        /// <returns>True if a match is found.</returns>
        /// <exception cref="ArgumentNullException"></exception>
        public static bool IsAnyOf<T>(this T p_parameter, params T[] p_comparisons)
        {
            // Validate
            p_parameter
                .CannotBeNull("p_parameter");
            p_comparisons
                .CannotBeNullOrEmpty("p_comparisons");

            // Test for any match
            foreach (var item in p_comparisons)
                if (p_parameter.Equals(item))
                    return true;

            // Return no matches found
            return false;
        }

        /// <summary>
        /// Validates if any passed in parameter is equal to null.
        /// </summary>
        /// <param name="p_parameters">Parameters to test for Null.</param>
        /// <returns>True if one or more parameters are null.</returns>
        public static bool IsAnyNull(params object[] p_parameters)
        {
            p_parameters
                .CannotBeNullOrEmpty("p_parameters");

            foreach (var item in p_parameters)
                if (item == null)
                    return true;

            return false;
        }
    }
}

namespace Common.FluentValidation
{
    public static partial class Validate
    {
        /// <summary>
        /// Validates the passed in parameter is not null, throwing a detailed exception message if the test fails.
        /// </summary>
        /// <param name="p_parameter">Parameter to validate.</param>
        /// <param name="p_name">Name of tested parameter to assist with debugging.</param>
        /// <exception cref="ArgumentNullException"></exception>
        public static void CannotBeNull(this object p_parameter, string p_name)
        {
            if (p_parameter == null)
                throw
                    new
                        ArgumentNullException(
                        string.Format("Parameter \"{0}\" cannot be null.",
                        p_name), default(Exception));
        }
    }
}

namespace Common.FluentValidation
{
    public static partial class Validate
    {
        /// <summary>
        /// Validates the passed in parameter is not null or an empty collection, throwing a detailed exception message if the test fails.
        /// </summary>
        /// <typeparam name="T"></typeparam>
        /// <param name="p_parameter">Parameter to validate.</param>
        /// <param name="p_name">Name of tested parameter to assist with debugging.</param>
        /// <exception cref="ArgumentNullException"></exception>
        /// <exception cref="ArgumentOutOfRangeException"></exception>
        public static void CannotBeNullOrEmpty<T>(this ICollection<T> p_parameter, string p_name)
        {
            if (p_parameter == null)
                throw new ArgumentNullException("Collection cannot be null.\r\nParameter_Name: " + p_name, default(Exception));

            if (p_parameter.Count <= 0)
                throw new ArgumentOutOfRangeException("Collection cannot be empty.\r\nParameter_Name: " + p_name, default(Exception));
        }

        /// <summary>
        /// Validates the passed in parameter is not null or empty, throwing a detailed exception message if the test fails.
        /// </summary>
        /// <param name="p_parameter">Parameter to validate.</param>
        /// <param name="p_name">Name of tested parameter to assist with debugging.</param>
        /// <exception cref="ArgumentException"></exception>
        public static void CannotBeNullOrEmpty(this string p_parameter, string p_name)
        {
            if (string.IsNullOrEmpty(p_parameter))
                throw new ArgumentException("String cannot be null or empty.\r\nParameter_Name: " + p_name, default(Exception));
        }
    }
}

Two Sample NUnit Unit Tests

Matching behaviour for Exception types is exact (ie. A child IS NOT a match for any of its parent types).

using System;
using System.Collections.Generic;
using Common.FluentValidation;
using NUnit.Framework;

namespace UnitTests.Common.Fluent_Validations
{
    [TestFixture]
    public class IsAnyOf_Tests
    {
        [Test, ExpectedException(typeof(ArgumentNullException))]
        public void IsAnyOf_ArgumentNullException_ShouldNotMatch_ArgumentException_Test()
        {
            Action TestMethod = () => { throw new ArgumentNullException(); };

            try
            {
                TestMethod();
            }
            catch (Exception ex)
            {
                if (ex.GetType().IsAnyOf(
                    typeof(ArgumentException), /*Note: ArgumentNullException derrived from ArgumentException*/
                    typeof(FormatException),
                    typeof(KeyNotFoundException)))
                {
                    // Handle expected Exceptions
                    return;
                }

                //else throw original
                throw;
            }
        }

        [Test, ExpectedException(typeof(OutOfMemoryException))]
        public void IsAnyOf_OutOfMemoryException_ShouldMatch_OutOfMemoryException_Test()
        {
            Action TestMethod = () => { throw new OutOfMemoryException(); };

            try
            {
                TestMethod();
            }
            catch (Exception ex)
            {
                if (ex.GetType().IsAnyOf(
                    typeof(OutOfMemoryException),
                    typeof(Exception)))
                    throw;

                /*else... Handle other exception types, typically by logging to file*/
            }
        }
    }
}

कैसा रहेगा

try
{
    WebId = Guid.Empty;
    WebId = new Guid(queryString["web"]);
}
catch (FormatException)
{
}
catch (OverflowException)
{
}

जैसा कि अन्य ने इंगित किया है, यह निर्धारित करने के लिए कि आपके पास क्या हो रहा है यह निर्धारित करने के लिए आपके कैच ब्लॉक के अंदर एक कथन हो सकता है। सी # 6 अपवाद फ़िल्टर का समर्थन करता है, इसलिए निम्नलिखित काम करेंगे:

try { … }
catch (Exception e) when (MyFilter(e))
{
    …
}

MyFilter विधि तब कुछ इस तरह दिख सकती है:

private bool MyFilter(Exception e)
{
  return e is ArgumentNullException || e is FormatException;
}

वैकल्पिक रूप से, यह सब इनलाइन किया जा सकता है (जब कथन का दायां हाथ सिर्फ बुलियन अभिव्यक्ति होना चाहिए)।

try { … }
catch (Exception e) when (e is ArgumentNullException || e is FormatException)
{
    …
}

यह catch ब्लॉक के भीतर से एक कथन का उपयोग करने से अलग है, अपवाद फ़िल्टर का उपयोग करके स्टैक को अनदेखा नहीं किया जाएगा

आप इसे देखने के लिए विजुअल स्टूडियो 2015 डाउनलोड कर सकते हैं।

यदि आप विजुअल स्टूडियो 2013 का उपयोग करना जारी रखना चाहते हैं, तो आप निम्न nuget पैकेज स्थापित कर सकते हैं:

इंस्टॉल-पैकेज Microsoft.Net.Compilers

लिखने के समय, इसमें सी # 6 के लिए समर्थन शामिल होगा।

इस पैकेज को संदर्भित करने से प्रोजेक्ट को सी # के विशिष्ट संस्करण और पैकेज में निहित विजुअल बेसिक कंपाइलर्स का उपयोग करके बनाया जाएगा, क्योंकि किसी भी सिस्टम स्थापित संस्करण के विपरीत।


पूर्णता के लिए, चूंकि .NET 4.0 कोड को फिर से लिखा जा सकता है:

Guid.TryParse(queryString["web"], out WebId);

TryParse कभी अपवाद फेंकता नहीं है और प्रारूप गलत है, तो WebId को Guid.Empty सेट करना गलत है।

चूंकि सी # 7 आप एक अलग रेखा पर एक चर को पेश करने से बच सकते हैं:

Guid.TryParse(queryString["web"], out Guid webId);

आप लौटने वाले टुपल्स को पार्स करने के तरीकों को भी बना सकते हैं, जो अभी तक संस्करण 4.6 के रूप में .NET Framework में उपलब्ध नहीं हैं:

(bool success, Guid result) TryParseGuid(string input) =>
    (Guid.TryParse(input, out Guid result), result);

और इन्हें इस तरह इस्तेमाल करें:

WebId = TryParseGuid(queryString["web"]).result;
// or
var tuple = TryParseGuid(queryString["web"]);
WebId = tuple.success ? tuple.result : DefaultWebId;

इस बेकार जवाब के लिए अगला बेकार अपडेट तब आता है जब बाहर पैरामीटर का निर्माण सी # 12. में लागू किया जाता है :)


यदि आप catch स्कोप में किसी कथन का उपयोग नहीं करना चाहते हैं, if C# 6.0 आप Exception Filters सिंटैक्स का उपयोग कर सकते हैं जो पहले से ही पूर्वावलोकन संस्करणों में सीएलआर द्वारा समर्थित था लेकिन केवल VB.NET / MSIL में मौजूद था:

try
{
    WebId = new Guid(queryString["web"]);
}
catch (Exception exception) when (exception is FormatException || ex is OverflowException)
{
    WebId = Guid.Empty;
}

यह कोड केवल Exception को पकड़ लेगा जब यह एक InvalidDataException Exception या ArgumentNullException

असल में, आप मूल रूप से किसी भी शर्त को उस स्थिति में डाल सकते हैं when खंड:

static int a = 8;

...

catch (Exception exception) when (exception is InvalidDataException && a == 8)
{
    Console.WriteLine("Catch");
}

ध्यान दें कि catch के दायरे के अंदर एक बयान के विपरीत, Exception Filters फेंक नहीं सकते हैं, और जब वे करते हैं, या जब स्थिति true नहीं होती true , तो अगली catch स्थिति की मूल्यांकन की जाएगी:

static int a = 7;

static int b = 0;

...

try
{
    throw new InvalidDataException();
}
catch (Exception exception) when (exception is InvalidDataException && a / b == 2)
{
    Console.WriteLine("Catch");
}
catch (Exception exception) when (exception is InvalidDataException || exception is ArgumentException)
{
    Console.WriteLine("General catch");
}

आउटपुट: सामान्य पकड़ो।

जब एक और अधिक Exception Filter - पहला व्यक्ति स्वीकार किया जाएगा:

static int a = 8;

static int b = 4;

...

try
{
    throw new InvalidDataException();
}
catch (Exception exception) when (exception is InvalidDataException && a / b == 2)
{
    Console.WriteLine("Catch");
}
catch (Exception exception) when (exception is InvalidDataException || exception is ArgumentException)
{
    Console.WriteLine("General catch");
}

आउटपुट: पकड़ो।

और जैसा कि आप MSIL में देख सकते हैं, MSIL का अनुवाद if बयानों में नहीं किया जाता है, लेकिन Filters , और Exceptions को Filter 1 और Filter 2 के साथ चिह्नित क्षेत्रों में से फेंक नहीं दिया जा सकता है लेकिन Exception फेंकने वाला फ़िल्टर इसके बजाय असफल हो जाएगा, आखिरी endfilter कमांड फ़िल्टर की सफलता / विफलता निर्धारित करने से पहले तुलना मूल्य स्टैक पर धक्का दिया जाता है ( Catch 1 एक्सओआर Catch 2 तदनुसार निष्पादित करेगा):

इसके अलावा, विशेष रूप से Guid.TryParse में Guid.TryParse विधि है।


यह मैट के उत्तर का एक रूप है (मुझे लगता है कि यह थोड़ा क्लीनर है) ... एक विधि का उपयोग करें:

public void TryCatch(...)
{
    try
    {
       // something
       return;
    }
    catch (FormatException) {}
    catch (OverflowException) {}

    WebId = Guid.Empty;
}

कोई अन्य अपवाद फेंक दिया जाएगा और कोड WebId = Guid.Empty; हिट नहीं किया जाएगा। यदि आप अन्य अपवादों को अपने प्रोग्राम को क्रैश नहीं करना चाहते हैं, तो बस इसे दो अन्य कैच के बाद जोड़ें:

...
catch (Exception)
{
     // something, if anything
     return; // only need this if you follow the example I gave and put it all in a method
}

सी # 6 में अनुशंसित दृष्टिकोण अपवाद फ़िल्टर का उपयोग करना है, यहां एक उदाहरण है:

 try
 {
      throw new OverflowException();
 }
 catch(Exception e ) when ((e is DivideByZeroException) || (e is OverflowException))
 {
       // this will execute iff e is DividedByZeroEx or OverflowEx
       Console.WriteLine("E");
 }

जोसेफ डाइगल का जवाब एक अच्छा समाधान है, लेकिन मुझे निम्न संरचना को थोड़ा सा और कम त्रुटि प्रवण होने के लिए मिला।

catch(Exception ex)
{   
    if (!(ex is SomeException || ex is OtherException)) throw;

    // Handle exception
}

अभिव्यक्ति को बदलने के कुछ फायदे हैं:

  • एक वापसी कथन आवश्यक नहीं है
  • कोड घोंसला नहीं है
  • यूसुफ के समाधान में अभिव्यक्ति से अलग किए गए 'फेंक' या 'रिटर्न' बयान को भूलने का कोई खतरा नहीं है।

इसे एक लाइन से भी संकुचित किया जा सकता है (हालांकि बहुत सुंदर नहीं)

catch(Exception ex) { if (!(ex is SomeException || ex is OtherException)) throw;

    // Handle exception
}

संपादित करें: सी # 6.0 में अपवाद फ़िल्टरिंग सिंटैक्स को थोड़ा क्लीनर बना देगा और किसी भी मौजूदा समाधान पर कई अन्य लाभों के साथ आता है। (सबसे विशेष रूप से ढेर बेकार छोड़कर)

यहां बताया गया है कि सी # 6.0 सिंटैक्स का उपयोग करने में एक ही समस्या कैसी दिखाई देगी:

catch(Exception ex) when (ex is SomeException || ex is OtherException)
{
    // Handle exception
}

System.Exception पकड़ो। System.Exception और प्रकारों पर स्विच करें

catch (Exception ex)            
{                
    if (ex is FormatException || ex is OverflowException)
    {
        WebId = Guid.Empty;
        return;
    }

    throw;
}

In c# 6.0,Exception Filters is improvements for exception handling

try
{
    DoSomeHttpRequest();
}
catch (System.Web.HttpException e)
{
    switch (e.GetHttpCode())
    {
        case 400:
            WriteLine("Bad Request");
        case 500:
            WriteLine("Internal Server Error");
        default:
            WriteLine("Generic Error");
    }
}

Just call the try and catch twice.

try
{
    WebId = new Guid(queryString["web"]);
}
catch (FormatException)
{
    WebId = Guid.Empty;
}
try
{
    WebId = new Guid(queryString["web"]);
}
catch (OverflowException)
{
    WebId = Guid.Empty;
}

It is just that Simple!!


Note that I did find one way to do it, but this looks more like material for The Daily WTF :

catch (Exception ex)
{
    switch (ex.GetType().Name)
    {
        case "System.FormatException":
        case "System.OverflowException":
            WebId = Guid.Empty;
            break;
        default:
            throw;
    }
}

Since I felt like these answers just touched the surface, I attempted to dig a bit deeper.

So what we would really want to do is something that doesn't compile, say:

// Won't compile... damn
public static void Main()
{
    try
    {
        throw new ArgumentOutOfRangeException();
    }
    catch (ArgumentOutOfRangeException)
    catch (IndexOutOfRangeException) 
    {
        // ... handle
    }

The reason we want this is because we don't want the exception handler to catch things that we need later on in the process. Sure, we can catch an Exception and check with an 'if' what to do, but let's be honest, we don't really want that. (FxCop, debugger issues, uglyness)

So why won't this code compile - and how can we hack it in such a way that it will?

If we look at the code, what we really would like to do is forward the call. However, according to the MS Partition II, IL exception handler blocks won't work like this, which in this case makes sense because that would imply that the 'exception' object can have different types.

Or to write it in code, we ask the compiler to do something like this (well it's not entirely correct, but it's the closest possible thing I guess):

// Won't compile... damn
try
{
    throw new ArgumentOutOfRangeException();
}
catch (ArgumentOutOfRangeException e) {
    goto theOtherHandler;
}
catch (IndexOutOfRangeException e) {
theOtherHandler:
    Console.WriteLine("Handle!");
}

The reason that this won't compile is quite obvious: what type and value would the '$exception' object have (which are here stored in the variables 'e')? The way we want the compiler to handle this is to note that the common base type of both exceptions is 'Exception', use that for a variable to contain both exceptions, and then handle only the two exceptions that are caught. The way this is implemented in IL is as 'filter', which is available in VB.Net.

To make it work in C#, we need a temporary variable with the correct 'Exception' base type. To control the flow of the code, we can add some branches. यहाँ जाता हैं:

    Exception ex;
    try
    {
        throw new ArgumentException(); // for demo purposes; won't be caught.
        goto noCatch;
    }
    catch (ArgumentOutOfRangeException e) {
        ex = e;
    }
    catch (IndexOutOfRangeException e) {
        ex = e;
    }

    Console.WriteLine("Handle the exception 'ex' here :-)");
    // throw ex ?

noCatch:
    Console.WriteLine("We're done with the exception handling.");

The obvious disadvantages for this are that we cannot re-throw properly, and -well let's be honest- that it's quite the ugly solution. The uglyness can be fixed a bit by performing branch elimination, which makes the solution slightly better:

Exception ex = null;
try
{
    throw new ArgumentException();
}
catch (ArgumentOutOfRangeException e)
{
    ex = e;
}
catch (IndexOutOfRangeException e)
{
    ex = e;
}
if (ex != null)
{
    Console.WriteLine("Handle the exception here :-)");
}

That leaves just the 're-throw'. For this to work, we need to be able to perform the handling inside the 'catch' block - and the only way to make this work is by an catching 'Exception' object.

At this point, we can add a separate function that handles the different types of Exceptions using overload resolution, or to handle the Exception. Both have disadvantages. To start, here's the way to do it with a helper function:

private static bool Handle(Exception e)
{
    Console.WriteLine("Handle the exception here :-)");
    return true; // false will re-throw;
}

public static void Main()
{
    try
    {
        throw new OutOfMemoryException();
    }
    catch (ArgumentException e)
    {
        if (!Handle(e)) { throw; }
    }
    catch (IndexOutOfRangeException e)
    {
        if (!Handle(e)) { throw; }
    }

    Console.WriteLine("We're done with the exception handling.");

And the other solution is to catch the Exception object and handle it accordingly. The most literal translation for this, based on the context above is this:

try
{
    throw new ArgumentException();
}
catch (Exception e)
{
    Exception ex = (Exception)(e as ArgumentException) ?? (e as IndexOutOfRangeException);
    if (ex != null)
    {
        Console.WriteLine("Handle the exception here :-)");
        // throw ?
    }
    else 
    {
        throw;
    }
}

So to conclude:

  • If we don't want to re-throw, we might consider catching the right exceptions, and storing them in a temporary.
  • If the handler is simple, and we want to re-use code, the best solution is probably to introduce a helper function.
  • If we want to re-throw, we have no choice but to put the code in a 'Exception' catch handler, which will break FxCop and your debugger's uncaught exceptions.

This is a classic problem every C# developer faces eventually.

Let me break your question into 2 questions. The first,

Can I catch multiple exceptions at once?

In short, no.

Which leads to the next question,

How do I avoid writing duplicate code given that I can't catch multiple exception types in the same catch() block?

Given your specific sample, where the fall-back value is cheap to construct, I like to follow these steps:

  1. Initialize WebId to the fall-back value.
  2. Construct a new Guid in a temporary variable.
  3. Set WebId to the fully constructed temporary variable. Make this the final statement of the try{} block.

So the code looks like:

try
{
    WebId = Guid.Empty;
    Guid newGuid = new Guid(queryString["web"]);
    // More initialization code goes here like 
    // newGuid.x = y;
    WebId = newGuid;
}
catch (FormatException) {}
catch (OverflowException) {}

If any exception is thrown, then WebId is never set to the half-constructed value, and remains Guid.Empty.

If constructing the fall-back value is expensive, and resetting a value is much cheaper, then I would move the reset code into its own function:

try
{
    WebId = new Guid(queryString["web"]);
    // More initialization code goes here.
}
catch (FormatException) {
    Reset(WebId);
}
catch (OverflowException) {
    Reset(WebId);
}

Wanted to added my short answer to this already long thread. Something that hasn't been mentioned is the order of precedence of the catch statements, more specifically you need to be aware of the scope of each type of exception you are trying to catch.

For example if you use a "catch-all" exception as Exception it will preceed all other catch statements and you will obviously get compiler errors however if you reverse the order you can chain up your catch statements (bit of an anti-pattern I think) you can put the catch-all Exception type at the bottom and this will be capture any exceptions that didn't cater for higher up in your try..catch block:

            try
            {
                // do some work here
            }
            catch (WebException ex)
            {
                // catch a web excpetion
            }
            catch (ArgumentException ex)
            {
                // do some stuff
            }
            catch (Exception ex)
            {
                // you should really surface your errors but this is for example only
                throw new Exception("An error occurred: " + ex.Message);
            }

I highly recommend folks review this MSDN document:

Exception Hierarchy


catch (Exception ex)
{
    if (!(
        ex is FormatException ||
        ex is OverflowException))
    {
        throw;
    }
    Console.WriteLine("Hello");
}




exception-handling